Index: /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,18 +25,8 @@
  *########################################################################
  */
-
- 
-
-
-
-
 package org.greenstone.gatherer.cdm;
 /**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Copyright:    Copyright (c) 2001
- * Company:      The University of Waikato
- * Written:      02/05/02
- * Revised:      17/11/02 - Commented
+ * Written:      ??/??/02
+ * Revised:      04/07/03 - DOM support
  **************************************************************************************/
 import java.awt.*;
@@ -56,152 +36,62 @@
 import javax.swing.event.*;
 import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
+import org.greenstone.gatherer.cdm.CollectionDesignManager;
+import org.greenstone.gatherer.cdm.Control;
+import org.greenstone.gatherer.cdm.DOMProxyListModel;
 import org.greenstone.gatherer.cdm.Subcollection;
-import org.greenstone.gatherer.cdm.SubIndex;
-import org.greenstone.gatherer.cdm.SubIndexes;
+import org.greenstone.gatherer.gui.NonWhitespaceField;
 import org.greenstone.gatherer.msm.ElementWrapper;
+import org.greenstone.gatherer.msm.MSMUtils;
 import org.greenstone.gatherer.util.ExclusiveListSelectionListener;
-import org.w3c.dom.Element;
-/** This class maintains a list of subcollections within our collection, and also records which of these subcollections we are building indexes for.
+import org.greenstone.gatherer.util.StaticStrings;
+import org.greenstone.gatherer.util.Utility;
+import org.w3c.dom.*;
+/** This class maintains a list of subcollections within our collection.
  * @author John Thompson, Greenstone Digital Library, University of Waikato
- * @version 2.1
+ * @version 2.4
  */
 public class SubcollectionManager
-    extends DefaultListModel {
-    /** A reference to the manager so we can get access to languages. */
-    private CollectionDesignManager manager;
+    extends DOMProxyListModel {
+
+    static final private String CLASS_DICTIONARY_NAME = "CDM.SubcollectionManager.";
+
     /** The controls used to edit the settings of this manager. */
     private Control controls = null;
-    /** A reference to this class so we can use it as a model in our inner classes. */
-    private DefaultListModel model = null;
-    /** The default index for the subcollections. */
-    private DefaultSubIndex default_index = null;
-    /** A reference to the Gatherer. */
-    private Gatherer gatherer = null;
-    /** A hashtable of subcollections, with mappings from name to subcollection. */
-    private Hashtable subcollections = null;
-    /** A vector-type structure of subcollection indexes. */
-    private SubIndexes subindexes = null;
-    /** A vector containing all of the subcollection commands that are unresolved, or in other words require that all 'subcollection <name> "<exp>"' to have been previously parsed before we can be certain their references will make sense. */
-    private ArrayList unresolved = null;
-    /** Constructor.
-     * @param gatherer A reference to the <Strong>Gatherer</strong>.
-     * @see org.greenstone.gatherer.cdm.SubIndexes
-     */
-    public SubcollectionManager(Gatherer gatherer, CollectionDesignManager manager) {
-	super();
-	this.gatherer = gatherer;
-	this.manager = manager;
+
+    private DOMProxyListModel model;
+
+    /** Constructor. 
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.cdm.CollectionConfiguration
+     * @see org.greenstone.gatherer.cdm.CollectionDesignManager
+     * @see org.greenstone.gatherer.cdm.DOMProxyListModel
+     * @see org.greenstone.gatherer.cdm.Subcollection
+     */
+    public SubcollectionManager() {
+	super(CollectionDesignManager.collect_config.getDocumentElement(), StaticStrings.SUBCOLLECTION_ELEMENT, new Subcollection());
+	Gatherer.println("SubcollectionManager: " + getSize() + " subcollections parsed.");
 	this.model = this;
-	this.subcollections = new Hashtable();
-	this.subindexes = new SubIndexes();
-	this.unresolved = new ArrayList();
-    }
-    /** Method to add a subindex.
-     * @param subindex A <strong>SubIndex</strong>.
+    }
+
+    /** Method to add a new subcollection.
+     * @param subcollection the Subcollection to add
      * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.cdm.CollectionConfiguration
+     * @see org.greenstone.gatherer.cdm.DOMProxyListModel
      * @see org.greenstone.gatherer.collection.CollectionManager
      */
-    public void addSubIndex(SubIndex subindex) {
-	if(!subindexes.contains(subindex)) {
-	    subindexes.addElement(subindex);
-	    gatherer.c_man.configurationChanged();
-	}
-    }
-    /** Method to add a new subcollection. Adds it to both the underlying list model and the hashtable mapping names to subcollections.
-	  * @param sub The <strong>Subcollection</strong> to add.
-	  * @return A <i>boolean</i> indicating if the addition was successful (<i>true</i>) or not (<i>false</i>).
-		* @see org.greenstone.gatherer.Gatherer
-		* @see org.greenstone.gatherer.collection.CollectionManager
-	  */
-    public boolean addSubcollection(Subcollection sub) {
-	if(!contains(sub)) {
-	    addElement(sub);
-	    subcollections.put(sub.getName(), sub);
-	    gatherer.c_man.configurationChanged();
-	    return true;
-	}
-	return false;
-    }
-    /** A method to add a new subcollection, by specifying its name, metadata element if applicable and Perl expression to filter pages into or out of this collection.
-     * @param name A <>>String</>> which is a unique identifier of a subcollection.
-     * @param include A <i>boolean</i> indicating whether this is an inclusion filter (<i>true</i>) or an exclusion one (<i>false</i>).
-     * @param element An <>>Element</>> which is either the metadata whose value should be matched against the given expression, or <i>null</i> if you wish to match against the file name.
-     * @param exp A <>>String</>> containing a Perl expression which is used as the filter for this subcollection.
-     * @param flags A <strong>String<strong> listing any special flags to be applied when matching the expression.
-     * @return A <i>boolean</i> with a value of <i>true</i> if the addition was successful.
-     * @see org.greenstone.gatherer.cdm.Subcollection
-     */
-    public boolean addSubcollection(String name, boolean include, String element, String exp, String flags) {
-	Subcollection sub = null;
-	if(element != null) {
-	    sub = new Subcollection(name, include, element, exp, flags);
-	}
-	else {
-	    sub = new Subcollection(name, include, exp, flags);
-	}
-	return addSubcollection(sub);
-    }
-    /** Refresh all derived components using this manager as a model.
-     */
-    public void changed() {
-	fireContentsChanged(this, 0, getSize() - 1);
-    }
-    /** Method to retrieve the controls for this manager.
-     * @return A <Strong>Control</strong> object which contains the controls used to edit the subcollection data.
-     */
-    public Control getControls() {
-	if(controls == null) {
-	    controls = new Control();
-	}
-	return controls;
-    }
-    /** Method to retrieve the default index.
-	  * @return A <strong>DefaultSubIndex</strong> object.
-	  */
-    public DefaultSubIndex getDefaultSubIndex() {
-	return default_index;
-    }
-    /** Method to retrieve a certain subcollection by its name.
-     * @param name A <strong>String</strong> which is used as the key for finding the matching subcollection.
-     * @return The requested <strong>Subcollection</strong> or <i>null</i> if no such subcollection exists.
-     */
-    public Subcollection getSubcollection(String name) {
-	return (Subcollection) subcollections.get(name);
-    }
-
-    /** Retrieve a certain subindex given its name.
-     * @param name the String representation of a subindex.
-     * @return the SubIndex requested or null if no such subindex.
-     */
-    public SubIndex getSubIndex(String name) {
-	for(int i = 0; i < subindexes.size(); i++) {
-	    SubIndex subindex = (SubIndex) subindexes.get(i);
-	    if(subindex.toString().equals(name)) {
-		return subindex;
-	    }
-	}
-	return null;
-    }
-
-    /** Method to get all of the subindexes set.
-     * @return A <strong>SubIndexes</strong> object containing all the defined indexes.
-     */
-    public SubIndexes getSubIndexes() {
-	return subindexes;
-    }
-    /** Method to get all of the subcollections defined.
-     * @return A <strong>Vector</strong> of subcollections.
-     */
-    public Vector getSubcollections() {
-	Vector subcollections = new Vector();
-	for(int i = 0; i < size(); i++) {
-	    subcollections.add(get(i));
-	}
-	return subcollections;
-    }
-    /** Mark the current controls, if any, as invalid and deallocate them. Any further use of the controls will requires them being rebuilt.
-     * @see org.greenstone.gatherer.cdm.SubcollectionManager.Control
-     */
-    public void invalidateControls() {
+    public void addSubcollection(Subcollection subcollection) {
+	if(!contains(subcollection)) {
+	    Element element = subcollection.getElement();
+	    // Locate where we should insert this new subcollection. 
+	    Node target_node = CollectionConfiguration.findInsertionPoint(element);
+	    // Failing that we insert immediately after a language string
+	    add(root, subcollection, target_node);
+	    Gatherer.c_man.configurationChanged();
+	}
+    }
+
+    public void destroy() {
 	if(controls != null) {
 	    controls.destroy();
@@ -209,322 +99,189 @@
 	}
     }
-    /** This method attempts to parse a subcollection related command from the given command string. If such a string is successfully parsed, it is immediately added to the data within this collection.
-     * @param command The <strong>String</strong> to be parsed.
-     * @param finished This <i>boolean</i> is usually <i>false</i> when called, unless this parse call is being made -after- the entire collection configuration file has been read in in which case it is <i>true</i>.
-     * @return A <i>boolean</i> which is <i>true</i> if a command was parsed, <i>false</i> otherwise.
-     * @see org.greenstone.gatherer.cdm.CommandTokenizer
-     * @see org.greenstone.gatherer.cdm.DefaultSubIndex
-     * @see org.greenstone.gatherer.cdm.Subcollection
-     * @see org.greenstone.gatherer.cdm.SubIndex
-     */
-    public boolean parse(String command, boolean finished) {
-	String temp = command.toLowerCase();
-	CommandTokenizer tokenizer = new CommandTokenizer(command);
-	tokenizer.nextToken(); // Throw away head.
-	if(temp.startsWith("subcollection")) {
-	    if(tokenizer.countTokens() >= 2) {
-		String name = tokenizer.nextToken();
-		String pattern = tokenizer.nextToken();
-		addSubcollection(new Subcollection(name, pattern));
-		return true;
-	    }
-	}
-	else if(temp.startsWith("indexsubcollections")) {
-				// These entries depend on what subcollections have previously been set, so we cannot safely parse them until after the file is complete.
-	    if(!finished) {
-		unresolved.add(command);
-	    }
-	    else {
-		while(tokenizer.hasMoreTokens()) {
-		    addSubIndex(new SubIndex(tokenizer.nextToken(), this));
-		}
-	    }
-	    return true;
-	}
-	else if(temp.startsWith("defaultsubcollection")) {
-				// These entries depend on what subcollections have previously been set, so we cannot safely parse them until after the file is complete.
-	    if(!finished) {
-		unresolved.add(command);
-	    }
-	    else {
-		if(tokenizer.hasMoreTokens()) {
-		    setDefaultSubIndex(new DefaultSubIndex(tokenizer.nextToken(), this));
-		}
-	    }
-	    return true;
-	}
-	return false;
-    }
-    /** Method to remove a certain subindex.
-	  * @param subindex The <strong>SubIndex</strong> you wish to remove.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.collection.CollectionManager
-	  */
-    public void removeSubIndex(SubIndex subindex) {
-	subindexes.removeElement(subindex);
-	gatherer.c_man.configurationChanged();
-    }
-    /** Method to remove all of the subindexes that contain a certain subcollection.
-	  * @param sub The <strong>Subcollection</strong> that you wish to remove.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.cdm.SubIndex
-	  * @see org.greenstone.gatherer.collection.CollectionManager
-	  */
-    public void removeSubIndexes(Subcollection sub) {
-	for(int i = subindexes.size() - 1; i >= 0; i--) {
-	    SubIndex subindex = (SubIndex)subindexes.get(i);
-	    if(subindex.containsSubcollection(sub.getName())) {
-		subindexes.removeElement(subindex);
-	    }
-	}
-	gatherer.c_man.configurationChanged();
-    }
+
+    /** Method to retrieve the controls for this manager.
+     * @return the Control used to edit the subcollection data
+     */
+    public Control getControls() {
+	if(controls == null) {
+	    controls = new SubcollectionControl();
+	}
+	return controls;
+    }
+
+    /** Method to retrieve a certain subcollection by its name.
+     * @param name a String which is used as the key for finding the matching subcollection
+     * @return the requested Subcollection or null if no such subcollection exists.
+     */
+    public Subcollection getSubcollection(String name) {
+	Subcollection result = null;
+	int size = getSize();
+	for(int i = 0; i < size; i++) {
+	    Subcollection subcollection = (Subcollection) getElementAt(i);
+	    if(subcollection.getName().equals(name)) {
+		result = subcollection;
+	    }
+	}
+	return result;
+    }
+
+    /** Method to get all of the subcollections defined.
+     * @return an ArrayList of subcollections
+     */
+    public ArrayList getSubcollections() {
+	return children();
+    }
+
     /** Method to remove the given subcollection.
-	  * @param sub The <strong>Subcollection</strong> you want to remove.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.collection.CollectionManager
-	  */
-    public void removeSubcollection(Subcollection sub) {
-	removeElement(sub);
-	subcollections.remove(sub);
-	gatherer.c_man.configurationChanged();
-    }
-    /** Method to retry the parsing of commands that were previously unable to be parsed as they referenced subcollections that may not have been instantiated.
-	  */
-    public void reparseUnresolved() {
-	for(int i = 0; i < unresolved.size(); i++) {
-	    parse((String)unresolved.get(i), true);
-	}
-	unresolved.clear();
-    }
-    /** Method to set the default subcollection index.
-	  * @param subcollection The <strong>Subcollection</strong> to use as the default index.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.collection.CollectionManager
-	  */
-    public void setDefaultSubIndex(DefaultSubIndex subindex) {
-	this.default_index = subindex;
-	if(subindex != null) {
-	    addSubIndex(subindex.getSubIndex());
-	}
-	gatherer.c_man.configurationChanged();
-    }
-    /** This method causes the contents of this manager to be converted to a string, which is accomplished by calling <i>toString()</i> on each subcollection, then printing out the contents of the index vector.
-	  * @return A <strong>String</strong> containing a block of configuration commands.
-		* @see org.greenstone.gatherer.cdm.SubIndex
-		* @see org.greenstone.gatherer.cdm.Subcollection
-	  */
-    public String toString() {
-	String text = "";
-	// Retrieve the subcollection names and sort them.
-	if(subcollections.size() > 0) {
-	    Vector names = new Vector(subcollections.keySet());
-	    Collections.sort(names);
-	    for(int i = 0; i < names.size(); i++) {
-		Subcollection sub =
-		    (Subcollection) subcollections.get(names.get(i));
-		text = text + sub.toString();
-	    }
-				// Now add a entry, separated by spaces for each subcollection
-				// index.
-	    if(subindexes.size() > 0) {
-		text = text + subindexes.toString();
-	    }
-				// Finally add the default subcollection index if necessary.
-	    if(default_index != null) {
-		text = text + default_index.toString();
-	    }
-	    text = text + "\n";
-	}
-	// Otherwise if there were no subcollections, there aren't going to be
-	// subcollection indexes, nor a default subcollection index are there.
-	return text;
-    }
+     * @param subcollection the Subcollection you want to remove
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.collection.CollectionManager
+     */
+    public void removeSubcollection(Subcollection subcollection) {
+	remove(subcollection);
+	Gatherer.c_man.configurationChanged();
+    }
+
+    public void updateSubcollection(Subcollection subcollection, String name, boolean include, String source, String pattern, String flags) {
+	subcollection.setFlags(flags);
+	subcollection.setInclusive(include);
+	subcollection.setName(name);
+	subcollection.setPattern(pattern);
+	subcollection.setSource(source);
+	refresh(subcollection);
+	Gatherer.c_man.configurationChanged();
+    }
+
     /** Method to retrieve a phrase from the dictionary based on a key.
-	  * @param key A <strong>String</strong> used to find the correct phrase.
-	  * @param args A <strong>String[]</strong> of arguments used in formatting and filling out the phrase.
-	  * @return A <strong>String</strong> containing the correct phrase with the correct formatting.
-	  */
+     * @param key A <strong>String</strong> used to find the correct phrase.
+     * @param args A <strong>String[]</strong> of arguments used in formatting and filling out the phrase.
+     * @return A <strong>String</strong> containing the correct phrase with the correct formatting.
+     */
     private String get(String key) {
-	return get(key, null);
-    }
-    /** Method to retrieve a phrase from the dictionary based on a key.
-	  * @param key A <strong>String</strong> used to find the correct phrase.
-	  * @return A <strong>String</strong> containing the correct phrase with the correct formatting.
-	  * @see org.greenstone.gatherer.Dictionary
-	  * @see org.greenstone.gatherer.Gatherer
-	  */
-    private String get(String key, String args[]) {
 	if(key.indexOf(".") == -1) {
-	    key = "CDM.SubcollectionManager." + key;
-	}
-	return gatherer.dictionary.get(key, args);
-    }
+	    key = CLASS_DICTIONARY_NAME + key;
+	}
+	return Gatherer.dictionary.get(key);
+    }
+
     /** This class creates a JPanel containing serveral more controls used for editing subcollection information. */
-    private class Control
-	extends JPanel {
-	/** <i>true</i> if the current selection has changed. */
-	private boolean changed = false;
-	/** Button to add a subcollection. */
-	private JButton add = null;
-	/** Button to add a subindex. */
-	private JButton add_index = null;
-	/** Button to clear the default subindex. */
-	private JButton clear_default = null;
-	/** Button to remove a subcollection. */
-	private JButton remove = null;
-	/** Button to remove a subindex. */
-	private JButton remove_index = null;
-	/** Button to set the default subindex. */
-	private JButton set_default = null;
-	/** Button to cause an update of the subcollections. */
-	private JButton update = null;
-	/** A combobox allowing you to choose which field the data for matching should be taken from. Includes text body and filename, as well as all assigned metadata elements. */
-	private JComboBox source = null;
-	/** The list of assigned subcollections. */
-	private JList subcollection_list = null;
-	/** The list of subcollections available for the creation of subindexes. */
-	private JList subcollection_list_2 = null;
-	/** The list of assigned subindexes. */
-	private JList subindexes_list = null;
-	/** The label denoting the list of subindexes. */
-	private JLabel subindexes_label = null;
-	/** The panel containing the subcollection controls. */
-	private JPanel subcollection_pane = null;
-	/** The panel containing the subindex controls. */
-	private JPanel subindex_pane = null;
-	/** The tabbed pane used to store the subcollection and subindex controls. */
-	private JTabbedPane tabbed_pane = null;
-	/** The area used to display inline instructions. */
-	private JTextArea instructions = null;
-	/** The field displaying the name of the default subindex. */
-	private JTextField default_value = null;
-	/** A field used for specifying flags for the PERL expression matching, such as 'i' for case insensitive. */
-	private JTextField flags = null;
-	/** The pattern the source text must match. */
-	private JTextField match = null;
-	/** The name of this subcollection. */
-	private JTextField name = null;
-	/** The name of this subindex. */
-	private JTextField subindex_name;
-	/** When this button is selected the filter matching files are excluded. */
-	private JToggleButton exclude = null;
-	/** When this button is selected the filter matching files are included. */
-	private JToggleButton include = null;
-	/** The existing subcollection whose details you are reviewing, if any. */
-	private Subcollection current = null;
-	/** Constructor, creates the outer parts of the view, then calls two methods in turn to create the subcollection controls and subindex controls.
-	 */
-	public Control() {
+    private class SubcollectionControl
+	extends JPanel 
+	implements Control {
+
+	private JButton add_button;
+	private JButton remove_button;
+	private JButton update_button;
+	private JComboBox source_combobox;
+	private JList subcollection_list;
+	private JTabbedPane tabbed_pane;
+	private JTextArea instructions_area;
+	private JTextField flags_field;
+	private JTextField match_field;
+	private JTextField name_field;
+	private JToggleButton exclude_button;
+	private JToggleButton include_button;
+
+	/** Constructor */
+	public SubcollectionControl() {
 	    // Create
 	    JPanel border_pane = new JPanel();
 	    JPanel header_pane = new JPanel();
-	    instructions = new JTextArea(get("Instructions"));
-	    instructions.setEditable(false);
-	    instructions.setLineWrap(true);
-	    instructions.setRows(5);
-	    instructions.setWrapStyleWord(true);
+	    instructions_area = new JTextArea(get("Instructions"));
+	    instructions_area.setEditable(false);
+	    instructions_area.setLineWrap(true);
+	    instructions_area.setRows(5);
+	    instructions_area.setWrapStyleWord(true);
 	    tabbed_pane = new JTabbedPane();
 	    JLabel title = new JLabel(get("Title"));
 	    title.setHorizontalAlignment(JLabel.CENTER);
-	    createSubCollection();
-	    createSubIndex();
+	    
+	    JPanel button_pane_3 = new JPanel();
+	    add_button = new JButton(get("Add"));
+	    add_button.setMnemonic(KeyEvent.VK_A);
+	    add_button.setEnabled(false);
+	    remove_button = new JButton(get("Remove"));
+	    remove_button.setMnemonic(KeyEvent.VK_R);
+	    remove_button.setEnabled(false);
+	    update_button = new JButton(get("Update"));
+	    update_button.setMnemonic(KeyEvent.VK_C);
+	    update_button.setEnabled(false);
+
+	    JPanel button_pane = new JPanel();
+	    JPanel button_pane_1 = new JPanel();
+	    exclude_button = new JToggleButton(get("Exclude"));
+	    exclude_button.setMnemonic(KeyEvent.VK_X);
+	    flags_field = new NonWhitespaceField();
+	    JLabel flags_label = new JLabel(get("Flags"));
+	    include_button = new JToggleButton(get("Include"));
+	    include_button.setMnemonic(KeyEvent.VK_I);
+	    JLabel inclusive_label = new JLabel(get("Inclusive"));
+	    JPanel inclusive_pane = new JPanel();
+	    match_field = new JTextField();
+	    JLabel match_label = new JLabel(get("Match"));
+	    name_field = new NonWhitespaceField();
+	    JLabel name_label = new JLabel(get("Name"));
+	    Vector source_model = Gatherer.c_man.getCollection().msm.getAssignedElements();
+	    source_model.add(0, StaticStrings.FILENAME_STR);
+	    source_combobox = new JComboBox(source_model);
+	    JLabel source_label = new JLabel(get("Source"));
+	    subcollection_list = new JList(model);
+	    subcollection_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
+	    JPanel subcollection_pane = new JPanel();
+	    ButtonGroup bg = new ButtonGroup();
+	    bg.add(include_button);
+	    bg.add(exclude_button);
+	    include_button.setSelected(true);
+	    JPanel subcollection_list_pane = new JPanel();
+	    JLabel subcollection_list_label = new JLabel(get("Assigned"));
+
 	    // Add listeners
+	    SubCollectionChangeListener cl = new SubCollectionChangeListener();
+	    add_button.addActionListener(new AddSubCollectionListener());
+	    remove_button.addActionListener(new RemoveSubCollectionListener());
+	    update_button.addActionListener(new UpdateSubCollectionListener());
+	    exclude_button.addActionListener(cl);
+	    include_button.addActionListener(cl);
+	    source_combobox.addActionListener(cl);
+	    flags_field.getDocument().addDocumentListener(cl);
+	    match_field.getDocument().addDocumentListener(cl);
+	    name_field.getDocument().addDocumentListener(cl);
+	    subcollection_list.addListSelectionListener(new SubCollectionListListener());
+
 	    // Layout
-	    instructions.setBorder(BorderFactory.createEmptyBorder(2,5,2,5));
+	    instructions_area.setBorder(BorderFactory.createEmptyBorder(2,5,2,5));
+
 	    header_pane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
 	    header_pane.setLayout(new BorderLayout());
 	    header_pane.add(title, BorderLayout.NORTH);
-	    header_pane.add(new JScrollPane(instructions), BorderLayout.CENTER);
-	    tabbed_pane.addTab(get("Subcollection_Controls"), subcollection_pane);
-	    tabbed_pane.addTab(get("Subindex_Controls"), subindex_pane);
-	    tabbed_pane.addTab(get("Language_Controls"), manager.languages.getControls());
-	    border_pane.setBorder(BorderFactory.createEmptyBorder(0,5,5,5));
-	    border_pane.setLayout(new BorderLayout());
-	    border_pane.add(tabbed_pane, BorderLayout.CENTER);
-	    setLayout(new BorderLayout());
-	    add(header_pane, BorderLayout.NORTH);
-	    add(border_pane, BorderLayout.CENTER);
-	}
-	/** Create the subcollection controls.
-	 * @see org.greenstone.gatherer.Gatherer
-	 * @see org.greenstone.gatherer.cdm.SubcollectionManager.Control.AddListener
-	 * @see org.greenstone.gatherer.cdm.SubcollectionManager.Control.ListListener
-	 * @see org.greenstone.gatherer.cdm.SubcollectionManager.Control.RemoveListener
-	 * @see org.greenstone.gatherer.collection.CollectionManager
-	 * @see org.greenstone.gatherer.msm.MetadataSetManager
-	 */
-	public void createSubCollection() {
-	    // Create
-	    add = new JButton(get("Add"));
-	    add.setMnemonic(KeyEvent.VK_A);
-	    add.setEnabled(false);
-	    JPanel button_pane = new JPanel();
-	    JPanel button_pane_1 = new JPanel();
-	    JPanel button_pane_3 = new JPanel();
-	    exclude = new JToggleButton(get("Exclude"));
-	    exclude.setMnemonic(KeyEvent.VK_X);
-	    flags = new JTextField();
-	    JLabel flags_label = new JLabel(get("Flags"));
-	    include = new JToggleButton(get("Include"));
-	    include.setMnemonic(KeyEvent.VK_I);
-	    JLabel inclusive_label = new JLabel(get("Inclusive"));
-	    JPanel inclusive_pane = new JPanel();
-	    match = new JTextField();
-	    JLabel match_label = new JLabel(get("Match"));
-	    name = new JTextField();
-	    JLabel name_label = new JLabel(get("Name"));
-	    remove = new JButton(get("Remove"));
-	    remove.setMnemonic(KeyEvent.VK_R);
-	    remove.setEnabled(false);
-	    Vector source_model = gatherer.c_man.msm.getAssignedElements();
-	    source_model.add(0, "Filename");
-	    source = new JComboBox(source_model);
-	    JLabel source_label = new JLabel(get("Source"));
-	    subcollection_list = new JList(model);
-	    subcollection_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
-	    subcollection_pane = new JPanel();
-	    ButtonGroup bg = new ButtonGroup();
-	    bg.add(include);
-	    bg.add(exclude);
-	    include.setSelected(true);
-	    JPanel subcollection_list_pane = new JPanel();
-	    JLabel subcollection_list_label = new JLabel(get("Assigned"));
-
-	    // Add listeners
-	    SubCollectionChangeListener cl = new SubCollectionChangeListener();
-	    add.addActionListener(new AddSubCollectionListener());
-	    remove.addActionListener(new RemoveSubCollectionListener());
-	    subcollection_list.addListSelectionListener(new SubCollectionListListener());
-	    //exclude.addActionListener(cl);
-	    //include.addActionListener(cl);
-	    //source.addActionListener(cl);
-	    //flags.addDocumentListener(cl);
-	    match.getDocument().addDocumentListener(cl);
-	    name.getDocument().addDocumentListener(cl);
-
-	    // Layout
+	    header_pane.add(new JScrollPane(instructions_area), BorderLayout.CENTER);
+
 	    inclusive_pane.setLayout(new GridLayout());
-	    inclusive_pane.add(include);
-	    inclusive_pane.add(exclude);
+	    inclusive_pane.add(include_button);
+	    inclusive_pane.add(exclude_button);
+
 	    button_pane_1.setBorder(BorderFactory.createEmptyBorder(5,0,0,0));
 	    button_pane_1.setLayout(new GridLayout(5, 2));
 	    button_pane_1.add(name_label);
-	    button_pane_1.add(name);
+	    button_pane_1.add(name_field);
 	    button_pane_1.add(source_label);
-	    button_pane_1.add(source);
+	    button_pane_1.add(source_combobox);
 	    button_pane_1.add(match_label);
-	    button_pane_1.add(match);
+	    button_pane_1.add(match_field);
 	    button_pane_1.add(inclusive_label);
 	    button_pane_1.add(inclusive_pane);
 	    button_pane_1.add(flags_label);
-	    button_pane_1.add(flags);
+	    button_pane_1.add(flags_field);
+
 	    button_pane_3.setBorder(BorderFactory.createEmptyBorder(5,0,0,0));
-	    button_pane_3.setLayout(new GridLayout(1,2));
-	    button_pane_3.add(add);
-	    button_pane_3.add(remove);
+	    button_pane_3.setLayout(new GridLayout(1,3));
+	    button_pane_3.add(add_button);
+	    button_pane_3.add(update_button);
+	    button_pane_3.add(remove_button);
+
 	    button_pane.setLayout(new BorderLayout());
 	    button_pane.add(button_pane_1, BorderLayout.CENTER);
 	    button_pane.add(button_pane_3, BorderLayout.SOUTH);
+
 	    subcollection_list_pane.setLayout(new BorderLayout());
 	    subcollection_list_pane.add(subcollection_list_label, BorderLayout.NORTH);
